Index: binaries/data/mods/public/maps/random/rmgen/heightmap_manipulation.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/heightmap_manipulation.js	(revision 0)
+++ binaries/data/mods/public/maps/random/rmgen/heightmap_manipulation.js	(working copy)
@@ -0,0 +1,472 @@
+/**
+*	Heightmap manipulation functionality
+*
+*	A heightmapt is an array of width arrays of height floats
+*	Width and height is normally mapSize+1 (Number of vertices is one bigger than number of tiles in each direction)
+*	The default heightmap is g_Map.height (See the Map object)
+*
+*	NOTE (ambiguous naming/potential confusion):
+*		For using this heightmap functionalities it is VITAL that TILE_CENTERED_HEIGHT_MAP = false (default)!
+*		Otherwise TILE_CENTERED_HEIGHT_MAP has nothing to do with any tile centered heightmap in this library!
+*		All tile centered heightmaps in this module are temporary objects only and should never replace g_Map.height!
+*		(Tile centered heightmaps are one less in width and hight than heightmaps used by the engine)
+*		(Multiple conversions will lead to strange smoothing effects at best and potentially break the map entirely!)
+*		In the long run TILE_CENTERED_HEIGHT_MAP should be removed and g_Map.height should never be tile centered...
+*/
+
+/**
+* getMinAndMaxHeight
+*	Optionally takes a heightmap, default is g_Map.height
+*	Returns the minimum and maximum heights present in this heightmap (an associative array of the form {"min": minHeight, "max": maxHeight})
+*/
+function getMinAndMaxHeight(heightmap)
+{
+	heightmap = (heightmap || g_Map.height)
+	var height = {};
+	height.min = Infinity;
+	height.max = - Infinity;
+	for (var x = 0; x < heightmap.length; ++x)
+	{
+		for (var y = 0; y < heightmap[x].length; ++y)
+		{
+			if (heightmap[x][y] < height.min)
+				height.min = heightmap[x][y];
+			else if (heightmap[x][y] > height.max)
+				height.max = heightmap[x][y];
+		}
+	}
+	return height;
+}
+
+/**
+* rescaleHeightmap
+*	Takes:
+*		Optional minHeight(float), minimum height that should be used for the resulting heightmap, default is MIN_HEIGHT
+*		Optional maxHeight(float), maximum height that should be used for the resulting heightmap, default is MAX_HEIGHT
+*		Optional heightmap, default is g_Map.height
+*	Rescales the heightmap so its minimum and maximum height is as the arguments told (preserving it's global shape)
+*/
+function rescaleHeightmap(minHeight, maxHeight, heightmap)
+{
+	minHeight = (minHeight || MIN_HEIGHT);
+	maxHeight = (maxHeight || MAX_HEIGHT);
+	heightmap = (heightmap || g_Map.height);
+	
+	var oldHeightRange = getMinAndMaxHeight(heightmap);
+	var max_x = heightmap.length;
+	var max_y = heightmap[0].length;
+	for (var x = 0; x < max_x; ++x)
+		for (var y = 0; y < max_y; ++y)
+			heightmap[x][y] = minHeight + (heightmap[x][y] - oldHeightRange.min) / (oldHeightRange.max - oldHeightRange.min) * (maxHeight - minHeight);
+}
+
+/**
+* getInclineMap
+*	Optionally takes a heightmap, default is g_Map.height
+*	Returns an inclination map corresponding to the tiles between the heightmaps vertices:
+*		array of heightmap width-1 arrays of height-1 vectors (associative arrays) of the from:
+*			{"x": x_slope, "y": y_slope] so a 2D Vector pointing to the hightest incline (with the length the incline in the vectors direction)
+* NOTE: The x and y coordinates of a tile in the terrain texture map correspond to those of the inclination map
+*/
+function getInclineMap(heightmap)
+{
+	heightmap = (heightmap || g_Map.height);
+	var max_x = heightmap.length - 1;
+	var max_y = heightmap[0].length - 1;
+	var inclineMap = [];
+	for (var x = 0; x < max_x; ++x)
+	{
+		inclineMap[x] = [];
+		for (var y = 0; y < max_y; ++y)
+		{
+			var dx = heightmap[x + 1][y] - heightmap[x][y];
+			var dy = heightmap[x][y + 1] - heightmap[x][y];
+			var next_dx = heightmap[x + 1][y + 1] - heightmap[x][y + 1];
+			var next_dy = heightmap[x + 1][y + 1] - heightmap[x + 1][y];
+			inclineMap[x][y] = {"x": 0.5 * (dx + next_dx), "y": 0.5 * (dy + next_dy)};
+		}
+	}
+	return inclineMap;
+}
+
+/**
+* getSlopeMap
+*	Optionally takes an inclineMap, default is getInclineMap(g_Map.height)
+*	Returns a slope map (same form as the a heightmap with one less width and height)
+* NOTES:
+*	Not normalized. Only returns the steepness (float), not the direction of incline.
+*	The x and y coordinates of a tile in the terrain texture map correspond to those of the slope map
+*/
+function getSlopeMap(inclineMap)
+{
+	inclineMap = (inclineMap || getInclineMap(g_Map.height));
+	var max_x = inclineMap.length;
+	var slopeMap = new Array(max_x);
+	for (var x = 0; x < max_x; ++x)
+	{
+		var max_y = inclineMap[x].length;
+		slopeMap[x] = new Float32Array(max_y);
+		for (var y = 0; y < max_y; ++y)
+			slopeMap[x][y] = Math.pow(inclineMap[x][y].x * inclineMap[x][y].x + inclineMap[x][y].y * inclineMap[x][y].y, 0.5);
+	}
+	return slopeMap;
+}
+
+/**
+* getTileCenteredHeightmap
+*	Optionally takes a heightmap, default is g_Map.height
+*	Returns an approximation of the heights of the tiles between the vertices, a tile centered heightmap
+*	NOTE:
+*		A tile centered heightmap is one smaller in width and height than an ordinary heightmap
+*		It is meant to e.g. texture a map by height (x/y coordinates correspond to those of the terrain texture map)
+*		Don't use this to override g_Map height (Potentially breaks the map)!
+*/
+function getTileCenteredHeightmap(heightmap)
+{
+	heightmap = (heightmap || g_Map.height);
+	var max_x = heightmap.length - 1;
+	var max_y = heightmap[0].length - 1;
+	var tchm = new Array(max_x);
+	for (var x = 0; x < max_x; ++x)
+	{
+		tchm[x] = new Float32Array(max_y);
+		for (var y = 0; y < max_y; ++y)
+		{
+			tchm[x][y] = 0.25 * (heightmap[x][y] + heightmap[x + 1][y] + heightmap[x][y + 1] + heightmap[x + 1][y + 1]);
+		}
+	}
+	return tchm;
+}
+
+/**
+*	getStartLocationsByHeightmap
+*
+*	Description:
+*		Get start location with the largest minimum distance between players
+*	Takes
+*		hightRange		An associative array with keys "min" and "max" each containing a float (the height range start locations are allowed)
+*		maxTries		Optional, default is 1000, an integer, how often random player distributions are rolled to be compared
+*		minDistToBorder	Optional, default is 20, an integer, how far start locations have to be away from the map border
+*		numberOfPlayers	Optional, default is g_MapSettings.PlayerData.length, an integer, how many start locations should be placed
+*		Heightmap		Optional, default is g_Map.height, the heightmap for the start locations to be placed on
+*	Returns
+*		An array of 2D points (arrays of length 2)
+*/
+function getStartLocationsByHeightmap(hightRange, maxTries, minDistToBorder, numberOfPlayers, heightmap)
+{
+	maxTries = (maxTries || 1000);
+	minDistToBorder = (minDistToBorder || 20);
+	numberOfPlayers = (numberOfPlayers || g_MapSettings.PlayerData.length);
+	heightmap = (heightmap || g_Map.height);
+	
+	var validStartLoc = [];
+	for (var x = minDistToBorder; x < heightmap.length - minDistToBorder; ++x)
+		for (var y = minDistToBorder; y < heightmap[0].length - minDistToBorder; ++y)
+			if (heightmap[x][y] > hightRange.min && heightmap[x][y] < hightRange.max) // Has the right hight
+				validStartLoc.push({"x": x, "y": y});
+	
+	var maxMinDist = 0;
+	for (var tries = 0; tries < maxTries; ++tries)
+	{
+		var startLoc = [];
+		var minDist = heightmap.length;
+		for (var p = 0; p < numberOfPlayers; ++p)
+			startLoc.push(validStartLoc[randInt(validStartLoc.length)]);
+		for (var p1 = 0; p1 < numberOfPlayers - 1; ++p1)
+		{
+			for (var p2 = p1 + 1; p2 < numberOfPlayers; ++p2)
+			{
+				var dist = getDistance(startLoc[p1].x, startLoc[p1].y, startLoc[p2].x, startLoc[p2].y);
+				if (dist < minDist)
+					minDist = dist;
+			}
+		}
+		if (minDist > maxMinDist)
+		{
+			maxMinDist = minDist;
+			var finalStartLoc = startLoc;
+		}
+	}
+	
+	return finalStartLoc;
+}
+
+/**
+*	distributeEntitiesByHeight
+*	Takes
+*		hightRange		An associative array with keys "min" and "max" each containing a float (the height range start locations are allowed)
+*		startLoc		An array of 2D points (arrays of length 2)
+*		heightmap		Optional, default is g_Map.height, an array of (map width) arrays of (map depth) floats
+*		entityList		Array of entities/actors (strings to be placed with placeObject())
+*		maxTries		Optional, default is 1000, an integer, how often random player distributions are rolled to be compared
+*		minDistance		Optional, default is 30, an integer, how far start locations have to be away from start locations and the map border
+*	Returns
+*		An array of 2D points (arrays of length 2)
+*/
+function distributeEntitiesByHeight(hightRange, startLoc, entityList, maxTries, minDistance, heightmap)
+{
+	entityList = (entityList || [rbe11, rbe13]);
+	maxTries = (maxTries || 1000);
+	minDistance = (minDistance || 30);
+	heightmap = (heightmap || g_Map.height);
+	
+	var placements = deepcopy(startLoc);
+	var validTiles = [];
+	for (var x = minDistance; x < heightmap.length - minDistance; ++x)
+		for (var y = minDistance; y < heightmap[0].length - minDistance; ++y)
+			if (heightmap[x][y] > hightRange.min && heightmap[x][y] < hightRange.max) // Has the right hight
+				validTiles.push({"x": x, "y": y});
+	
+	for (var tries = 0; tries < maxTries; ++tries)
+	{
+		var tile = validTiles[randInt(validTiles.length)];
+		var isValid = true;
+		for (var p = 0; p < placements.length; ++p)
+		{
+			if (getDistance(placements[p].x, placements[p].y, tile.x, tile.y) < minDistance)
+			{
+				isValid = false;
+				break;
+			}
+		}
+		if (isValid)
+		{
+			placeObject(tile.x, tile.y, entityList[randInt(entityList.length)], 0, randFloat(0, 2*PI));
+			// placeObject(tile[0], tile[1], "actor|geology/decal_stone_medit_b.xml", 0, randFloat(0, 2*PI));
+			placements.push(tile);
+		}
+	}
+}
+
+/**
+*	setBaseTerrainDiamondSquare
+*
+*	Description:
+*		Sets the heightmap to a relatively realistic shape.
+*	Takes:
+*		minHeight			Optional, Float, Default is the absolute possible minimum height
+*							Minimum height that can occur in the resulting heightmap
+*		maxHeight			Optional, Float, Default is the absolute possible maximum height
+*							Maximum height that can occur in the resulting heightmap
+*		smoothness			Optional, Float between 0 (rough) to 1 (smooth), Default is 0.5
+*							Lower values (rough) will generate more local structures (but should be smoothed e.g. with erosion later)
+*		initialHeightmap	Optional, Array of width Arrays of depth Floats (usually a small square heightmap e.g. 2x2)
+*							Sets some initial heights at the edges (square heightmap of size 2) or more more specifically with bigger initial heightmaps
+*		heightmap			Optional, Array of width Arrays of depth Floats (a heightmap), Default is g_Map.height
+*							The heightmap that will be set by this function
+*	Returns nothing
+*	NOTES:
+*		min/maxHeight will not necessarily be present in the heightmap
+*		This function only supports rectangular heightmaps.
+*			This means that e.g. the edges (given by initialHeightmap) will not be in the playable map area in circular maps.
+*		The function doubles the size of the initial heightmap (if given, else a random 2x2 one) until it's big enough.
+*			Then the extend is cut. So the impact and scale of the initial heightmap depends on its size and the target map size.
+*/
+function setBaseTerrainDiamondSquare(minHeight, maxHeight, smoothness, initialHeightmap, heightmap)
+{
+	// Make some arguments optional
+	minHeight = (minHeight || MIN_HEIGHT);
+	maxHeight = (maxHeight || MAX_HEIGHT);
+	var heightRange = maxHeight - minHeight;
+	if (heightRange <= 0)
+		warn("setBaseTerrainDiamondSquare: heightRange < 0");
+	smoothness = (smoothness || 0.5);
+	initialHeightmap = (initialHeightmap || [[randFloat(minHeight / 2, maxHeight / 2), randFloat(minHeight / 2, maxHeight / 2)], [randFloat(minHeight / 2, maxHeight / 2), randFloat(minHeight / 2, maxHeight / 2)]]);
+	heightmap = (heightmap || g_Map.height);
+	
+	var offset = heightRange / 2;
+	
+	// Double initialHeightmap width until target width is reached (diamond square method)
+	while (initialHeightmap.length < heightmap.length)
+	{
+		var newHeightmap = [];
+		var oldWidth = initialHeightmap.length;
+		// Square
+		for (var x = 0; x < 2 * oldWidth - 1; ++x)
+		{
+			newHeightmap.push([]);
+			for (var y = 0; y < 2 * oldWidth - 1; ++y)
+			{
+				if (x % 2 == 0 && y % 2 == 0) // Old tile
+					newHeightmap[x].push(initialHeightmap[x/2][y/2]);
+				else if (x % 2 == 1 && y % 2 == 1) // New tile with diagonal old tile neighbors
+				{
+					newHeightmap[x].push((initialHeightmap[(x-1)/2][(y-1)/2] + initialHeightmap[(x+1)/2][(y-1)/2] + initialHeightmap[(x-1)/2][(y+1)/2] + initialHeightmap[(x+1)/2][(y+1)/2]) / 4);
+					newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+				}
+				else // New tile with straight old tile neighbors
+					newHeightmap[x].push(undefined); // Define later
+			}
+		}
+		// Diamond
+		for (var x = 0; x < 2 * oldWidth - 1; ++x)
+		{
+			for (var y = 0; y < 2 * oldWidth - 1; ++y)
+			{
+				if (newHeightmap[x][y] === undefined)
+				{
+					if (x > 0 && x + 1 < newHeightmap.length - 1 && y > 0 && y + 1 < newHeightmap.length - 1) // Not a border tile
+					{
+						newHeightmap[x][y] = (newHeightmap[x+1][y] + newHeightmap[x][y+1] + newHeightmap[x-1][y] + newHeightmap[x][y-1]) / 4;
+						newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+					}
+					else if (x < newHeightmap.length - 1 && y > 0 && y < newHeightmap.length - 1) // Left border
+					{
+						newHeightmap[x][y] = (newHeightmap[x+1][y] + newHeightmap[x][y+1] + newHeightmap[x][y-1]) / 3;
+						newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+					}
+					else if (x > 0 && y > 0 && y < newHeightmap.length - 1) // Right border
+					{
+						newHeightmap[x][y] = (newHeightmap[x][y+1] + newHeightmap[x-1][y] + newHeightmap[x][y-1]) / 3;
+						newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+					}
+					else if (x > 0 && x < newHeightmap.length - 1 && y < newHeightmap.length - 1) // Bottom border
+					{
+						newHeightmap[x][y] = (newHeightmap[x+1][y] + newHeightmap[x][y+1] + newHeightmap[x-1][y]) / 3;
+						newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+					}
+					else if (x > 0 && x < newHeightmap.length - 1 && y > 0) // Top border
+					{
+						newHeightmap[x][y] = (newHeightmap[x+1][y] + newHeightmap[x-1][y] + newHeightmap[x][y-1]) / 3;
+						newHeightmap[x][y] += (newHeightmap[x][y] - minHeight) / heightRange * randFloat(-offset, offset)
+					}
+				}
+			}
+		}
+		initialHeightmap = deepcopy(newHeightmap);
+		offset /= Math.pow(2, smoothness);
+	}
+	
+	// Cut initialHeightmap to fit target width
+	var shift = [floor((newHeightmap.length - heightmap.length) / 2), floor((newHeightmap[0].length - heightmap[0].length) / 2)];
+	for (var x = 0; x < heightmap.length; ++x)
+		for (var y = 0; y < heightmap[0].length; ++y)
+			heightmap[x][y] = newHeightmap[x][y];
+}
+
+/**
+*	globalSmoothHeightmap
+*
+*	Takes:
+*		strength	Optional, Float between 0 (no effect) and 1 (2 appending tiles will be set to roughly the same height), default is 0.8
+*					How strong the smooth effect should be
+*		heightmap	Optional, Array of width Arrays of depth Floats (a heightmap), Default is g_Map.height
+*					The heightmap to be smoothed
+*	Returns nothing
+*	NOTES:
+*		Strength values >0.9 might result in interference.
+*		To strengthen the smooth effect it's better to apply it multiple times than using high strength values.
+*/
+function globalSmoothHeightmap(strength, heightmap)
+{
+	strength = (strength || 0.8); // 0 to 1
+	heightmap = (heightmap || g_Map.height);
+	
+	var referenceHeightmap = deepcopy(heightmap);
+	// var map = [[1, 0], [0, 1], [-1, 0], [0, -1]]; // faster
+	var map = [[1, 0], [1, 1], [0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1]]; // smoother
+	var max_x = heightmap.length;
+	var max_y = heightmap[0].length;
+	for (var x = 0; x < max_x; ++x)
+	{
+		for (var y = 0; y < max_y; ++y)
+		{
+			for (var i = 0; i < map.length; ++i)
+			{
+				var mapX = x + map[i][0];
+				var mapY = y + map[i][1];
+				if (mapX >= 0 && mapX < max_x && mapY >= 0 && mapY < max_y)
+					heightmap[x][y] += strength / map.length * (referenceHeightmap[mapX][mapY] - referenceHeightmap[x][y]);
+			}
+		}
+	}
+}
+
+/**
+*	rectangularSmoothToHeight
+*
+*	Description:
+*		Pushes a rectangular area towards a given height smoothing it into the original terrain
+*	Takes:
+*		center			Associative Array with keys x and y containing Floats (the x/y coordinates of the center)
+*		dx/dy			Float, Distance from the center in x/y direction the rectangle ends (half width/depth)
+*		targetHeight	Float, Height the center of the rectangle will be pushed to
+*		strength		Float between 0 (no change) to 1 (center set to target height), how strong the height is pushed
+*		heightmap		Optional, Array of width Arrays of depth Floats (a heightmap), Default is g_Map.height
+*						The heightmap to be manipulated
+*	Returns nothing
+*	NOTES:
+*		The window function to determine the smooth is not exactly a gaussian to ensure smooth edges.
+*		The optimal function is not clear so several working ones are left in the function (documented out)
+*/
+function rectangularSmoothToHeight(center, dx, dy, targetHeight, strength, heightmap)
+{
+	var x = round(center.x);
+	var y = round(center.y);
+	dx = round(dx);
+	dy = round(dy);
+	strength = (strength || 1);
+	heightmap = (heightmap || g_Map.height);
+	
+	var heightmapWin = [];
+	for (var wx = 0; wx < 2 * dx + 1; ++wx)
+	{
+		heightmapWin.push([]);
+		for (var wy = 0; wy < 2 * dy + 1; ++wy)
+		{
+			var actualX = x - dx + wx;
+			var actualY = y - dy + wy;
+			if (actualX >= 0 && actualX < heightmap.length - 1 && actualY >= 0 && actualY < heightmap[0].length - 1) // Is in map
+				heightmapWin[wx].push(heightmap[actualX][actualY]);
+			else
+				heightmapWin[wx].push(targetHeight);
+		}
+	}
+	for (var wx = 0; wx < 2 * dx + 1; ++wx)
+	{
+		for (var wy = 0; wy < 2 * dy + 1; ++wy)
+		{
+			var actualX = x - dx + wx;
+			var actualY = y - dy + wy;
+			if (actualX >= 0 && actualX < heightmap.length - 1 && actualY >= 0 && actualY < heightmap[0].length - 1) // Is in map
+			{
+				// // Window function rectangle
+				// var scaleX = 1;
+				// var scaleY = 1;
+				// // Window function triangle
+				// var scaleX = min(min(wx / dx, (2 * dx + 1 - wx) / dx), 1);
+				// var scaleY = min(min(wy / dy, (2 * dy + 1 - wy) / dy), 1);
+				// // Window function trapeze
+				// var scaleX = min(min(1.3 * wx / dx, 1.3 * (2 * dx + 1 - wx) / dx), 1);
+				// var scaleY = min(min(1.3 * wy / dy, 1.3 * (2 * dy + 1 - wy) / dy), 1);
+				// // Window function simple sine (range PI)
+				// var scaleX = sin(wx * PI / (2 * dx + 1));
+				// var scaleY = sin(wy * PI / (2 * dy + 1));
+				// // Window function cosine (range 2*PI)
+				// var scaleX = (cos((wx - (2 * dx + 1) / 2) * 2 * PI / (2 * dx + 1)) + 1) / 2;
+				// var scaleY = (cos((wy - (2 * dy + 1) / 2) * 2 * PI / (2 * dy + 1)) + 1) / 2;
+				// // Window function polynomial 2nd degree (BEST SINGLE SO FAR)
+				var scaleX = 1 - (wx / dx - 1) * (wx / dx - 1);
+				var scaleY = 1 - (wy / dy - 1) * (wy / dy - 1);
+				// // Window function polynomial 4th degree
+				// var scaleX = (wx / dx - 1) * (wx / dx - 1) * (wx / dx - 1) * (wx / dx - 1) - 2 * (wx / dx - 1) * (wx / dx - 1) + 1;
+				// var scaleY = (wy / dy - 1) * (wy / dy - 1) * (wy / dy - 1) * (wy / dy - 1) - 2 * (wy / dy - 1) * (wy / dy - 1) + 1;
+				// COMBINATIONS
+				// // Window function arithmetic mean of simple sine (range PI) and trapeze
+				// var scaleX = (sin(wx * PI / (2 * dx + 1)) + min(min(2.1 * wx / dx, 2.1 * (2 * dx + 1 - wx) / dx), 1)) / 2;
+				// var scaleY = (sin(wy * PI / (2 * dy + 1)) + min(min(2.1 * wy / dy, 2.1 * (2 * dy + 1 - wy) / dy), 1)) / 2;
+				// // Window function arithmetic mean of cosine (range 2*PI) and trapeze
+				// var scaleX = ((cos((wx - (2 * dx + 1) / 2) * 2 * PI / (2 * dx + 1)) + 1) / 2 + min(min(5 * wx / dx, 5 * (2 * dx + 1 - wx) / dx), 1)) / 2;
+				// var scaleY = ((cos((wy - (2 * dy + 1) / 2) * 2 * PI / (2 * dy + 1)) + 1) / 2 + min(min(5 * wy / dy, 5 * (2 * dy + 1 - wy) / dy), 1)) / 2;
+				// // Window function arithmetic mean of polynomial 2nd degree and trapeze (BEST COMBINATION SO FAR)
+				// var scaleX = (1 - (wx / dx - 1) * (wx / dx - 1) + min(min(3 * wx / dx, 3 * (2 * dx + 1 - wx) / dx), 1)) / 2;
+				// var scaleY = (1 - (wy / dy - 1) * (wy / dy - 1) + min(min(3 * wy / dy, 3 * (2 * dy + 1 - wy) / dy), 1)) / 2;
+				
+				if (scaleX < 0 || scaleY < 0 || scaleX > 1 || scaleY > 1) // DEBUG
+					warn("rectangularSmoothToHeight: Scale < 0 or > 1: scaleX = " + scaleX + ", scaleY = " + scaleY); // DEBUG
+				heightmap[actualX][actualY] = heightmapWin[wx][wy] + strength * scaleX * scaleY * (targetHeight - heightmapWin[wx][wy]);
+				// g_Map.setTexture(actualX, actualY, "red"); // DEBUG
+			}
+		}
+	}
+}
